package com.ruoyi.oa.service;

import com.ruoyi.oa.domain.SysOaTaskItem;
import com.ruoyi.oa.domain.vo.SysOaTaskItemVo;
import com.ruoyi.oa.domain.bo.SysOaTaskItemBo;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;

import java.util.Collection;
import java.util.List;

/**
 * 报工任务单元Service接口
 *
 * @author hdka
 * @date 2025-03-27
 */
public interface ISysOaTaskItemService {

    /**
     * 查询报工任务单元
     */
    SysOaTaskItemVo queryById(Long itemId);

    /**
     * 查询报工任务单元列表
     */
    TableDataInfo<SysOaTaskItemVo> queryPageList(SysOaTaskItemBo bo, PageQuery pageQuery);

    /**
     * 查询报工任务单元列表
     */
    List<SysOaTaskItemVo> queryList(SysOaTaskItemBo bo);

    /**
     * 新增报工任务单元
     */
    Boolean insertByBo(SysOaTaskItemBo bo);

    /**
     * 修改报工任务单元
     */
    Boolean updateByBo(SysOaTaskItemBo bo);

    /**
     * 校验并批量删除报工任务单元信息
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 提交报工表单后新建表单
     * @param bo
     * @return
     */
    Boolean reportSubmit(SysOaTaskItemBo bo);

    /**
     * 推迟申请
     * @param bo
     * @return
     */
    Boolean postpone(SysOaTaskItemBo bo);
}
